Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security.cert
Class Certificate

    java.lang.Object
      |
      +--java.security.cert.Certificate

All Implemented Interfaces:
  Serializable

Direct Known Subclasses:
  X509Certificate

public abstract class Certificate
extends Object
implements Serializable

Abstract class for managing a variety of identity certificates. An identity certificate is a binding of a principal to a public key which is vouched for by another principal. (A principal represents an entity such as an individual user, a group, or a corporation.)

This class is an abstraction for certificates that have different formats but important common uses. For example, different types of certificates, such as X.509 and PGP, share general certificate functionality (like encoding and verifying) and some types of information (like a public key).

X.509, PGP, and SDSI certificates can all be implemented by subclassing the Certificate class, even though they contain different sets of information, and they store and retrieve the information in different ways.

See Also:
  `X509Certificate`, `CertificateFactory`, Serialized Form

Inner Class Summary
`protected static class` | `Certificate.CertificateRep` Alternate Certificate class for serialization.

Constructor Summary
`protected` | `Certificate(String type)` Creates a certificate of the specified type.

Method Summary
`boolean` | `equals(Object other)` Compares this certificate for equality with the specified object.
`abstract byte[]` | `getEncoded()` Returns the encoded form of this certificate.
`abstract PublicKey` | `getPublicKey()` Gets the public key from this certificate.
`String` | `getType()` Returns the type of this certificate.
`int` | `hashCode()` Returns a hashcode value for this certificate from its encoded form.
`abstract String` | `toString()` Returns a string representation of this certificate.
`abstract void` | `verify(PublicKey key)` Verifies that this certificate was signed using the private key that corresponds to the specified public key.
`abstract void` | `verify(PublicKey key, String sigProvider)` Verifies that this certificate was signed using the private key that corresponds to the specified public key.
`protected Object` | `writeReplace()` Replace the Certificate to be serialized.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Certificate

    protected Certificate(String type)

  Creates a certificate of the specified type.
  Parameters:
    `type` - the standard name of the certificate type. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard certificate types.

Method Detail

### getType

    public final String getType()

  Returns the type of this certificate.
  Returns:
    the type of this certificate.

### equals

    public boolean equals(Object other)

  Compares this certificate for equality with the specified object. If the `other` object is an `instanceof` `Certificate`, then its encoded form is retrieved and compared with the encoded form of this certificate.
  Overrides:
    `equals` in class `Object`
  Parameters:
    `other` - the object to test for equality with this certificate.
  Returns:
    true iff the encoded forms of the two certificates match, false otherwise.

### hashCode

    public int hashCode()

  Returns a hashcode value for this certificate from its encoded form.
  Overrides:
    `hashCode` in class `Object`
  Returns:
    the hashcode value.

### getEncoded

    public abstract byte[] getEncoded()
                               throws CertificateEncodingException

  Returns the encoded form of this certificate. It is assumed that each certificate type would have only a single form of encoding; for example, X.509 certificates would be encoded as ASN.1 DER.
  Returns:
    the encoded form of this certificate
  Throws:
    `CertificateEncodingException` - if an encoding error occurs.

### verify

    public abstract void verify(PublicKey key)
                         throws CertificateException,
                                NoSuchAlgorithmException,
                                InvalidKeyException,
                                NoSuchProviderException,
                                SignatureException

  Verifies that this certificate was signed using the private key that corresponds to the specified public key.
  Parameters:
    `key` - the PublicKey used to carry out the verification.
  Throws:
    `NoSuchAlgorithmException` - on unsupported signature algorithms.
    `InvalidKeyException` - on incorrect key.
    `NoSuchProviderException` - if there's no default provider.
    `SignatureException` - on signature errors.
    `CertificateException` - on encoding errors.

### verify

    public abstract void verify(PublicKey key,
                                String sigProvider)
                         throws CertificateException,
                                NoSuchAlgorithmException,
                                InvalidKeyException,
                                NoSuchProviderException,
                                SignatureException

  Verifies that this certificate was signed using the private key that corresponds to the specified public key. This method uses the signature verification engine supplied by the specified provider.
  Parameters:
    `key` - the PublicKey used to carry out the verification.
    `sigProvider` - the name of the signature provider.
  Throws:
    `NoSuchAlgorithmException` - on unsupported signature algorithms.
    `InvalidKeyException` - on incorrect key.
    `NoSuchProviderException` - on incorrect provider.
    `SignatureException` - on signature errors.
    `CertificateException` - on encoding errors.

### toString

    public abstract String toString()

  Returns a string representation of this certificate.
  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this certificate.

### getPublicKey

    public abstract PublicKey getPublicKey()

  Gets the public key from this certificate.
  Returns:
    the public key.

### writeReplace

    protected Object writeReplace()
                           throws ObjectStreamException

  Replace the Certificate to be serialized.
  Returns:
    the alternate Certificate object to be serialized.
  Throws:
    `ObjectStreamException` - if a new object representing this certificate could not be created

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.